#include <bits/stdc++.h>

using namespace std;

#ifdef TEST
#   define DEBUG(x) cout << x << endl
#else
#   define DEBUG(x)
#endif

int edit_distance(const char* x, const char* y) {
    unordered_map<int, unordered_map<int, int>> res;
    function<int(int, int)> fun = [&](int a, int b) -> int {
        if(a < 0 || b < 0) return INT_MAX - 1;
        if(a == 0) return b;
        if(b == 0) return a;
        if(res[a].find(b) == res[a].end()) {
            res[a][b] = min(min(fun(a, b-1) + 1, fun(a-1, b) + 1),
                fun(a-1,b-1) + (x[a-1] == y[b-1] ? 0 : 1));
            DEBUG(a << " " << b << " => " << res[a][b]);
        }
        return res[a][b];
    };
    return fun(strlen(x), strlen(y));
}

int main() {
    cout << edit_distance("LOVE", "MOVIE") << endl;
    
    return 0;
}

